"""Add path

Revision ID: 1f8a526aae9b
Revises: 615b9338dc2e
Create Date: 2019-09-09 19:04:43.664008

"""
from alembic import op
import sqlalchemy as sa


# revision identifiers, used by Alembic.
revision = '1f8a526aae9b'
down_revision = '615b9338dc2e'
branch_labels = None
depends_on = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.add_column('actuators', sa.Column('klass', sa.String(length=50), nullable=True))
    op.add_column('actuators', sa.Column('path', sa.String(length=1024), nullable=True))
    op.drop_constraint('actuators_gateway_id_fkey', 'actuators', type_='foreignkey')
    op.create_foreign_key(None, 'actuators', 'gateways', ['gateway_id'], ['id'], ondelete='CASCADE')
    op.drop_constraint('chunk_devices_chunk_id_fkey', 'chunk_devices', type_='foreignkey')
    op.drop_constraint('chunk_devices_device_id_fkey', 'chunk_devices', type_='foreignkey')
    op.create_foreign_key(None, 'chunk_devices', 'chunks', ['chunk_id'], ['id'], ondelete='CASCADE')
    op.create_foreign_key(None, 'chunk_devices', 'devices', ['device_id'], ['id'], ondelete='CASCADE')
    op.drop_constraint('chunks_stream_id_fkey', 'chunks', type_='foreignkey')
    op.create_foreign_key(None, 'chunks', 'streams', ['stream_id'], ['id'], ondelete='CASCADE')
    op.add_column('gateways', sa.Column('klass', sa.String(length=50), nullable=True))
    op.add_column('gateways', sa.Column('path', sa.String(length=1024), nullable=True))
    op.add_column('sensors', sa.Column('klass', sa.String(length=50), nullable=True))
    op.add_column('sensors', sa.Column('path', sa.String(length=1024), nullable=True))
    op.drop_constraint('sensors_gateway_id_fkey', 'sensors', type_='foreignkey')
    op.create_foreign_key(None, 'sensors', 'gateways', ['gateway_id'], ['id'], ondelete='CASCADE')
    op.drop_constraint('settings_actuator_id_fkey', 'settings', type_='foreignkey')
    op.drop_constraint('settings_stream_id_fkey', 'settings', type_='foreignkey')
    op.drop_constraint('settings_sensor_id_fkey', 'settings', type_='foreignkey')
    op.drop_constraint('settings_user_id_fkey', 'settings', type_='foreignkey')
    op.drop_constraint('settings_gateway_id_fkey', 'settings', type_='foreignkey')
    op.create_foreign_key(None, 'settings', 'users', ['user_id'], ['id'], ondelete='CASCADE')
    op.create_foreign_key(None, 'settings', 'streams', ['stream_id'], ['id'], ondelete='CASCADE')
    op.create_foreign_key(None, 'settings', 'sensors', ['sensor_id'], ['id'], ondelete='CASCADE')
    op.create_foreign_key(None, 'settings', 'actuators', ['actuator_id'], ['id'], ondelete='CASCADE')
    op.create_foreign_key(None, 'settings', 'gateways', ['gateway_id'], ['id'], ondelete='CASCADE')
    op.drop_constraint('stream_devices_stream_id_fkey', 'stream_devices', type_='foreignkey')
    op.drop_constraint('stream_devices_device_id_fkey', 'stream_devices', type_='foreignkey')
    op.create_foreign_key(None, 'stream_devices', 'streams', ['stream_id'], ['id'], ondelete='CASCADE')
    op.create_foreign_key(None, 'stream_devices', 'devices', ['device_id'], ['id'], ondelete='CASCADE')
    op.drop_constraint('stream_history_stream_id_fkey', 'stream_history', type_='foreignkey')
    op.create_foreign_key(None, 'stream_history', 'streams', ['stream_id'], ['id'], ondelete='CASCADE')
    op.add_column('streams', sa.Column('path', sa.String(length=1024), nullable=True))
    op.drop_constraint('streams_gateway_id_fkey', 'streams', type_='foreignkey')
    op.create_foreign_key(None, 'streams', 'gateways', ['gateway_id'], ['id'], ondelete='CASCADE')
    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_constraint(None, 'streams', type_='foreignkey')
    op.create_foreign_key('streams_gateway_id_fkey', 'streams', 'gateways', ['gateway_id'], ['id'])
    op.drop_column('streams', 'path')
    op.drop_constraint(None, 'stream_history', type_='foreignkey')
    op.create_foreign_key('stream_history_stream_id_fkey', 'stream_history', 'streams', ['stream_id'], ['id'])
    op.drop_constraint(None, 'stream_devices', type_='foreignkey')
    op.drop_constraint(None, 'stream_devices', type_='foreignkey')
    op.create_foreign_key('stream_devices_device_id_fkey', 'stream_devices', 'devices', ['device_id'], ['id'])
    op.create_foreign_key('stream_devices_stream_id_fkey', 'stream_devices', 'streams', ['stream_id'], ['id'])
    op.drop_constraint(None, 'settings', type_='foreignkey')
    op.drop_constraint(None, 'settings', type_='foreignkey')
    op.drop_constraint(None, 'settings', type_='foreignkey')
    op.drop_constraint(None, 'settings', type_='foreignkey')
    op.drop_constraint(None, 'settings', type_='foreignkey')
    op.create_foreign_key('settings_gateway_id_fkey', 'settings', 'gateways', ['gateway_id'], ['id'])
    op.create_foreign_key('settings_user_id_fkey', 'settings', 'users', ['user_id'], ['id'])
    op.create_foreign_key('settings_sensor_id_fkey', 'settings', 'sensors', ['sensor_id'], ['id'])
    op.create_foreign_key('settings_stream_id_fkey', 'settings', 'streams', ['stream_id'], ['id'])
    op.create_foreign_key('settings_actuator_id_fkey', 'settings', 'actuators', ['actuator_id'], ['id'])
    op.drop_constraint(None, 'sensors', type_='foreignkey')
    op.create_foreign_key('sensors_gateway_id_fkey', 'sensors', 'gateways', ['gateway_id'], ['id'])
    op.drop_column('sensors', 'path')
    op.drop_column('sensors', 'klass')
    op.drop_column('gateways', 'path')
    op.drop_column('gateways', 'klass')
    op.drop_constraint(None, 'chunks', type_='foreignkey')
    op.create_foreign_key('chunks_stream_id_fkey', 'chunks', 'streams', ['stream_id'], ['id'])
    op.drop_constraint(None, 'chunk_devices', type_='foreignkey')
    op.drop_constraint(None, 'chunk_devices', type_='foreignkey')
    op.create_foreign_key('chunk_devices_device_id_fkey', 'chunk_devices', 'devices', ['device_id'], ['id'])
    op.create_foreign_key('chunk_devices_chunk_id_fkey', 'chunk_devices', 'chunks', ['chunk_id'], ['id'])
    op.drop_constraint(None, 'actuators', type_='foreignkey')
    op.create_foreign_key('actuators_gateway_id_fkey', 'actuators', 'gateways', ['gateway_id'], ['id'])
    op.drop_column('actuators', 'path')
    op.drop_column('actuators', 'klass')
    # ### end Alembic commands ###
