import asyncio
import logging

from package.shared.config import Config
from package.shared.handlers import ESDataHandler
from package.shared.util import get_request_json


syncing: bool = False

def do_sync(obj):
    global syncing

    if syncing:
        return

    syncing = True
    logging.info("syncing")

    try:
        handler = ESDataHandler()
        handler.handle(obj)
    except:
        logging.exception("Sync exception")

    syncing = False


async def run_sync():
    global syncing
    config = Config.get()

    while True:
        url = f"{config.app.server_web}/esdata?gateway={config.app.gateway}"

        try:
            rs = await get_request_json(url)
            do_sync(rs['obj'])
        except:
            logging.exception("Request esdata exception")

        await asyncio.sleep(int(config.app.sync_period))

